# poo2024


# Programmation orientée objet 2024

Prof. Stéphane Malandain et prof. Yassin Rekik

## Organisation technique

- Etape 1 : liker le _repo_
- Etape 2 : cloner le _repo_:
```
ssh://git@ssh.hesge.ch:10572/stephane.malandai/poo2023.git
```
- Mise à jour du _repo_:
```
git pull
```

## Ressources

- Installez openjdk (LTS) sur vos machines personnelles
- Vérifiez que vous avez le `jshell` d'installé
- [Javadoc d'Oracle](https://docs.oracle.com/en/java/javase/11/docs/api/index.html)
- [Maven in 5 minutes](https://maven.apache.org/guides/getting-started/maven-in-five-minutes.html)
- Bonne documentation sur git : [git-scm : les bases](https://git-scm.com/book/fr/v1/Les-bases-de-Git-Enregistrer-des-modifications-dans-le-d%C3%A9p%C3%B4t)
- [Conventions de nommage Java](https://www.oracle.com/technetwork/java/codeconventions-135099.html)

Pour ceux qui utilisent [Docker](https://docs.docker.com/), une image contenant tous ces outils est disponible ici : https://hub.docker.com/r/hepia/ubuntu-java

## Organisation administrative

### Extrait du règlement

- La participation aux activités pédagogiques est obligatoire
- Le plagiat est considéré comme une faute grave et peut entrainer à une exmatriculation
- L’étudiante ou l’étudiant qui invoque un cas de force majeure pour justifier son absence à un contrôle continu ou à une évaluation doit présenter une requête écrite, accompagnée de pièces justificatives, à la direction d’hepia dans les trois jours ouvrables [...]. 
  - Vos justifications doivent être envoyée à M. Ody Jean-Eudes.
  - Précisez qu'il doit nous transmettre l'acceptation ou le refus par email.
  - Informez nous juste de votre absence. La cause est à justifier auprès du bureau de la gestion académique


### Vos obligations

- Tous les exercices permettent d'atteindre les objectifs du cours
- les exercices seront partiellement corrigés en classe. Ils ne sont pas notés. 
- Le projet est obligatoire et noté. Toutes les étapes sont à rendre aux dates annoncés.

### Disponibilités des assistants/enseignants

- Stéphane Malandain (enseignant principal cours du jour) 
  - Vous pouvez me contacter par email pour prendre rendez-vous ou pour des questions administratives ou d'ordre général
  - Vos questions **techniques et théoriques seront ignorées** -> venez au cours,
    - Je réponds toutefois à vos questions à mon bureau en **B506** le **vendredi de 10h à 12h**
- Yassin Rekik (enseignant principal cours du soir) 
    - Vous pouvez me contacter par email pour prendre rendez-vous ou pour des questions administratives ou d'ordre général
    - Vos questions **techniques et théoriques seront ignorées** -> venez au cours,
    - Je réponds toutefois à vos questions à mon bureau en **A401** le **lundi de 17h à 18h30**
- Kevin Heirich répond à vos questions à son bureau **A403** les: 
    - **Mercredi** de **13h30 à 16h30**
    - **Jeudi** de **13h30 à 16h30**
- Nicolas Deronsart répond à vos questions à son bureau **I309** les: 
    - **Vendredi** de **10h à 12h**


## Evaluation
- 3 tests écrits qui donnent une note **N1**
- 4 etapes d'un projet qui donnent une note **N2**
- Test machine qui donne une note **N3**
- Pondération pour note finale : **40 % N1, 30% N2, 30% N3**              
 
## Programme

### Semaine 1 (mardi 17.09 - Vendredi 20.09)

- Théorie chapitre 1 : les bases de Java (début)
- Présentation IDE - Git - Maven
- Exercices série 1

### Semaine 2 (Ma 24.09 - Ve 27.09)

- Théorie chapitre 1 : les bases de Java (fin)
- Quiz chapitre 1
- Présentation Projet

### Semaine 3 (Ma 01.10 - Ve 04.10)

- Théorie chapitre 2 : classes et objets 
- Exercices série 2
- Correction exercices serie 1

### Semaine 4 (Ma 08.10 - Ve 11.10)

- Théorie chapitre 3 : Héritage (début)
- Projet
- Exercices série 2

### Semaine 5 (Ma 15.10 - Ve 18.10)

- Théorie chapitre 3 : Héritage (fin)
- Correction exercices série 2
- Exercices série 3
- **Test 1** (env. 30 minutes)

### Semaine sans cours (Ma 22.10 - Ve 25.11)

### Semaine 6 (Ma 29.10 - Ve 01.11)

- Correction test 1
- Théorie chapitre 4 : Le polymorphisme
- Exercices série 3  
- Etape 1 du projet à rendre le 03/11

### Semaine 7 (Ma 05.10 - Ve 08.11)

- Correction exercices série 3
- Théorie chapitre 5 : Les collections
- Exercices série 5  
- Projet

### Semaine 8 (Ma 12.11 - Ve 15.11)

- **Test 2** (env. 30 minutes)
- Champs : tous ce que l'on a vu jusqu'au polymorphisme 
- Formulaire a4 recto autorisé (manuscrit ou imprimé)
- Exercices série 5

### Semaine 9 (Ma 19.11 - Ve 22.11)

- Théorie chapitre 6 : Les types imbriqués
- Théorie chapitre 7 : Les exceptions
- Correction exercices série 5

### Semaine 10 (Ma 26.11 - Ve 29.11)

- Théorie chapitre 8 : Les classes génériques
- Correction test 2
- Exercices série 6_7_8


### Semaine 11 (Ma 03.12 - Ve 06.12)

- Chapitre pratique 1 : Les tests unitaires
- Fin etape 2 - Projet
- Etudiant du JOUR : Etape 2 du projet à rendre 10.12 


### Semaine 12 (Ma 10.12 - Ve 13.12)

- Théorie chapitre pratique 2 : Java FX / Programmation évènementielle
- Etudiant du SOIR : Etape 2 du projet à rendre 11.12 
- Enoncé étape 3

### Semaine 13 (Ma 17.12 - Ve 20.12)

- Théorie chapitre 9 : programmation fonctionnelle
- Théorie chapitre 10 : Les Streams
- exercices séries 9 et 10
- Correction exercices série 6-7-8

### Semaine 14 (Ma 17.12 - Ve 20.12)  

- Petit complément de cours : la serialisation
- video : http://gofile.me/6Zy9q/qZoRJaVtY
- Correction exercices series 9 et 10

### Semaine sans cours (Ma 24.12 - Ve 27.12) 

### Semaine sans cours (Ma 31.01 - Ve 03.01) 

### Semaine 14 (Ma 07.01 - Ve 10.12)  

- Petit complément de cours : la serialisation
- video : http://gofile.me/6Zy9q/qZoRJaVtY
- Correction exercices series 9 et 10

### Semaine 15 (Ma 14.01 - Ve 17.01)

- **Test 3**
- env. 60 minutes
- Champs : tout ce que l'on a vu depuis le début jusqu'au stream (chap.10 )
- Formulaire a4 recto/verso autorisé (manuscrit ou imprimé)

### Semaine 16 (Ve 24.01)

- 17.01 JOUR : Examen final sur machine Nexus (180 mn) 
- Tout ce que vous avez besoin (enoncé exos, corrigés, doc Java) sera sur la machine
- Editeur : Visual studio code
- Formulaire a4 recto/verso autorisé (manuscrit ou imprimé)
- Stylo + papier brouillon
- Etape 3 du projet à rendre pour le 24.01

### Semaine 17 (Ma 28.01)

- 21.01 JOUR : Examen final sur machine Nexus (180 mn) ETUDIANT DU SOIR !
- Tout ce que vous avez besoin (enoncé exos, corrigés, doc Java) sera sur la machine
- Editeur : Visual studio code
- Formulaire a4 recto/verso autorisé (manuscrit ou imprimé)
- Stylo + papier brouillon
- Etape 3 du projet à rendre pour le 24.01

